
// DemoApplicationDlg.h : header file
//

#pragma once
#include "tchart.h"
#include<vector>
#include<string>

// CDemoApplicationDlg dialog
class CDemoApplicationDlg : public CDialogEx
{
// Construction
public:
	CDemoApplicationDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_DEMOAPPLICATION_DIALOG };


	
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

public:
	void PlotChart();
	void PlotColorGridChart();
	CTChart	m_Chart;
	void SaveViewFile(CString file);
	void PlotPolygon();
	void EditPolygon();
	std::vector<std::string> sPolyNames;
	std::vector<double> xEdit;
	std::vector<double> yEdit;
	std::vector<double> xx;
	std::vector<double> yy;
	int iEditPolyVerticesSer;
	std::vector<int> Points;
	int iEditPolySegment;
	void AddPointToPolygon(int polyID, double x, double y);
	int addpointPos;
	void GetSegmentAdjacents(long X, long Y);
	double adjX1 , adjX2 , adjY1 , adjY2;
	int Polytolerance;
	bool ISAddPolygonPoint;
	bool IsPolygonVertexSelected(long X, long Y);
	int pickPoint_x, pickPoint_y;//stores the value of mouse coordinate at click start
	bool IsVertexFound;
	void HighlightPolygonVertices(int iDNo);
	bool IsSegmentFound;
	bool DeletePointFromPolygon(int polyID, double x, double y);
	bool ISDeletePoint;
	bool IsPolygonSegmentSelected(long X, long Y);
	int PolySer ;
	int numPolygon;
	void SetPolygonToleranceFactor();
// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
// 	afx_msg void OnBnClickedButton2();
// 	afx_msg void OnBnClickedButton1();
	DECLARE_EVENTSINK_MAP()
	void OnDblClickTchart1();
	afx_msg void OnBnClickedPlotPolygonButton();
	afx_msg void OnBnClickedEditPolyButton();
	afx_msg void OnBnClickedEndEditButton();
	void OnDragPointToolDragPointTchart1(long Index);
	void OnMouseMoveTchart1(long Shift, long X, long Y);
	void OnMouseUpTchart1(long Button, long Shift, long X, long Y);
	void OnMouseDownTchart1(long Button, long Shift, long X, long Y);
};
